// anagrafe.cpp
//

#include <iostream>
#include <cmath>
#include <vector>
#include <string>
#include <limits>

#define MAX_AGE 140

using namespace std;

class Municipality_record{
private: 
string name;
int age;

public:
string get_name();
int get_age();
Municipality_record(string n, int a);
};

Municipality_record::Municipality_record(string n, int a):
name(n), age(a){}
string Municipality_record::get_name(){return name;}
int Municipality_record::get_age(){return age;}

Municipality_record* read_record()
{
    cout<<"Per favore inserisci il cognome dell'iscritto all'anagrafe e poi digita enter (digita 0 per terminare)\n";
    string read_name;
    while(!(cin>>read_name))
    {
        if (cin.eof())
        {
            throw string("Nessun cognome inserito");
        }
        else
        {
            cin.clear();
            cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
            cout<<"Valore inaccettabile, devi inserire una stringa... riprova\n";
        }
    }

    if (read_name == "0") 
    {
    Municipality_record* m = new Municipality_record("0",-1);   
    return m;
    }
 
    cout<<"Adesso inserisci l'eta' in anni (deve essere un numero intero)\n";
    int read_age;
    while(!(cin>>read_age))
    {
        if (cin.eof())
        {
            throw string("Nessuna eta' inserita");
        }
        else
        {
            cin.clear();
            cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
            cout<<"Valore inaccettabile, devi inserire un numero intero... riprova\n";
        }
    }

    Municipality_record* m = new Municipality_record(read_name,read_age);   
    return m;
}


int main()
{
    cout<<"\nProgramma per il calcolo del massimo, minimo, media, e istogramma delle eta' degli iscritti all'anagrafe del Comune di Roncobilaccio.\n\n";
    try{
    
    vector<Municipality_record*> municipality_database;
    Municipality_record* m = read_record();
    
    while (m->get_name() != "0")
       {
        municipality_database.push_back(m);
        m = read_record();
        }
    
    int pos_min = 0;
    int pos_max = 0;
    float sum = 0;
    int current_age;
    vector<int> histogram(MAX_AGE);

    for(int i = 0; i < MAX_AGE; ++i)
        histogram[i]=0;

    for(int i = 0; i < municipality_database.size(); ++i)
        {
        current_age = municipality_database[i]->get_age(); 
        sum+= current_age;
        if (current_age < municipality_database[pos_min]->get_age())
           pos_min = i; 
        if (current_age > municipality_database[pos_max]->get_age())
           pos_max = i;
        ++histogram[current_age];
         }
      
     if (municipality_database.size() > 0)
        {
     cout << "\nUna delle persone con eta' minima (" << municipality_database[pos_min]->get_age() << " anni) si chiama " << municipality_database[pos_min]->get_name();
     cout << "\nUna delle persone con eta' massima (" << municipality_database[pos_max]->get_age() << " anni) si chiama " << municipality_database[pos_max]->get_name();
     cout << "\nL'eta' media e' " << sum/municipality_database.size() << " anni\n";
     cout << "\nIstogramma delle eta' comprese tra la minima e la massima";
     for(int i = municipality_database[pos_min]->get_age();  i <= municipality_database[pos_max]->get_age(); ++i)
        cout << "\n" << i << "\t" <<  histogram[i];
       }
    else 
       cout << "\nNon ci sono iscritti all'anagrafe\n";
  
    cout<<"\n\nGrazie per aver usato il nostro programma!\n";
    }
    catch(string& e)
    {cout<<"Errore nella lettura da input\n"<<e<<"\n";}
    catch(...)
    {cout<<"Errore ignoto\n";}
    //keep_window_open("Ciao");
    return 0;
}



