// cubeRoot.cpp
//

#include <iostream>
#include <cmath>
#include <limits>
using namespace std;

float read_number(string user_prompt)
    //
{
    float read_value;
    cout<<user_prompt;
    while(!(cin>>read_value))
    {
        if (cin.eof())
        {
            throw string("Nessun numero inserito");
        }
        else
        {
            cin.clear();
            cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
            cout<<"Valore inaccettabile; riprova ed inserisci un numero\n"<<user_prompt;
        }
    }
    return read_value;
}
float cube(const float x)
{return x*x*x;}
float squared_distance(const float x, const float y)
{return (x-y)*(x-y);}
int main()
{
    cout<<"\nProgramma per il calcolo della radice cubica con il metodo di Halley\n";
    //leggo a, n ed x0 copiando la funzione vista a lezione per reali
    try{
    //numero a da approssimare
    const float a = read_number("\nInserire il valore di cui si vuole calcolare la radice cubica: ");
    //numero di approssimazioni
    int iterations = (int) read_number("\nInserire il numero di iterazioni che si vogliono eseguire: ");
    //punto iniziale del calcolo delle approssimazioni
    float x = read_number("\nInserire il punto di partenza per il calcolo della radice cubica: ");
    float sum=squared_distance(cube(x),a); // sum iniziale calcolata su x0
    cout << "\nx0: " << x << ", sum: " << sum << endl;
    //ciclo
    //calcolo sommatoria (x_i3-a) man mano
    for (int i = 1;i<=iterations;++i)
    {
    //calcolo x_i+1 = x_i*(x_i3+2a)/(2x_i3+a)
        const float cube_x = cube(x);
        x *= (cube_x+2*a)/(2*cube_x+a); 
    //incremento sommatoria con x_i3-a
        sum+=squared_distance(cube(x),a); cout << "\nx" << i << ": " << x << ", sum: " << sum << endl;
    //fine ciclo
    }
    //restituisco sqrt della sommatoria divisa per il numero di approssimazioni calcolate, inclusa x_0
    cout<<"\nLa radice cubica di "<<a<<" approssimata alla iterazione " <<iterations<<" e' "<<x;
    cout<<"\nLo scarto quadratico medio delle prime "<<iterations+1<<" approssimazioni della radice cubica di "<<a<<" con il metodo di Halley (incluso il punto iniziale) e' " <<sqrt(sum/(iterations+1));
    cout<<"\nGrazie per aver usato il nostro programma!\n";
    }
    catch(string& e)
    {cout<<"Errore nella lettura da input\n"<<e<<"\n";}
    catch(...)
    {cout<<"Errore ignoto\n";}
    //keep_window_open("Ciao");
    return 0;
}



